;================= infra =======================19/12/06==
;------------------------------------------------------------
;     configure programmer
	LIST P=16F628;f=inhx8m
	#include "P16F628.INC"  ; Include header file
	__CONFIG	_PWRTE_ON  & _WDT_OFF & _INTRC_OSC_NOCLKOUT & _BODEN_ON & _LVP_OFF & _CP_OFF & _MCLRE_OFF
; http://sandiding.tripod.com/Bertys.html
;------------------------------------------------------------
	cblock 0x20	; Beginn General Purpose-Register
;-------------------------- counters	
	count1
	count2
	count3
;-------------------------- registrii transfer
	cod
	irid
	lamp
;--------------------------
	endc
;--------------------------
#DEFINE infra	PORTB,4
;--- Reset --------------------------------------------------
	org	h'00'
	goto	init		; reset -> init
;--- Interrupt ----------------------------------------------
	org	h'04'
	goto	los
;************************************************************************
init	nop
	bcf	STATUS,RP0	; Bank 0
	clrf	PORTA
	clrf	PORTB
	movlw	0x07		; Turn comparators off and enable pins for I/O 
	movwf	CMCON	
	bsf	STATUS,RP0	; Bank 1
	movlw	0xFF
	movwf	TRISA
	movlw	0xF0	; output
	movwf	TRISB
	bcf	STATUS,RP0	; Bank 0
	movlw	0x01
	movwf	lamp
los	bcf	INTCON,RBIE
	bcf	INTCON,RBIF
	bsf	INTCON,RBIE
;************************************************************************
start	clrf	cod
	clrf	irid
	call	halta
	btfsc	infra
	goto	start
	call	halta
	btfsc	infra
	goto	start
	call	halta
	btfsc	infra
	goto	start
	call	haltb
	movlw	0x07	; first 7 bits	  
	movwf	count2
wdhh	nop
	btfss	infra
	goto	wdhh
	call	warte
	call	haltb
	btfsc	infra
	goto	start
	rrf	cod,F
	bcf	cod,7
	call	halta
	btfss	infra
	bsf	cod,7
	decfsz	count2,F	
	goto 	wdhh
	rrf	cod,F
	bcf	cod,7
;***************************************************
	movlw	0x05	; next 5 bits	  
	movwf	count2
wdhl	nop
	btfss	infra
	goto	wdhl
	call	warte
	call	haltb
	btfsc	infra
	goto	start
	rrf	irid,F
	bcf	irid,7
	call	halta
	btfss	infra
	bsf	irid,7
	decfsz	count2,F	
	goto 	wdhl
	rrf	irid,F
	bcf	irid,7
	rrf	irid,F
	bcf	irid,7
	rrf	irid,F
	bcf	irid,7
;***************************************************
	movlw	0x03
	subwf	irid,W
	btfss	STATUS,Z ;test zero bit
	goto	start
	movlw	0x4E
	subwf	cod,W
	btfss	STATUS,Z ;test zero bit
	goto	tst1
	call	up_timer
	goto	start
tst1	movlw	0x4C
	subwf	cod,W
	btfss	STATUS,Z ;test zero bit
	goto	tst2
	call	dw_timer
	goto	start
tst2	movlw	0x4D
	subwf	cod,W
	btfss	STATUS,Z ;test zero bit
	goto	tst3
	call	set_timer
	goto	start
tst3	movlw	0x4F
	subwf	cod,W
	btfss	STATUS,Z ;test zero bit
	goto	start
	call	off_timer
	goto	start	
;***************************************************
up_timer
	movlw	0x08
	subwf	lamp,W
	btfsc	STATUS,Z ;test zero bit
	goto	top
	incf	lamp,F
top	call	span
	movwf	CCPR1L
	call	pause
	return
;***************************************************
dw_timer
	movf	lamp,F
	btfsc	STATUS,Z ;test zero bit
	goto	hop
	decf	lamp,F
hop	call	span
	movwf	CCPR1L
	call	pause
	return
;***************************************************
off_timer
	bcf	T2CON,TMR2ON
	movlw	0x01
	movwf	lamp
	clrf	CCP1CON
	clrf	PORTB
	call	pause
	sleep
	return
;***************************************************
set_timer
	clrf	T2CON
	clrf	TMR2
	bcf	INTCON,7
	bsf	STATUS,RP0
	clrf	PIE1
	bcf	STATUS,RP0
	clrf	PIR1
	bsf	STATUS,RP0
	movlw	0xFF
	movwf	PR2 ; compare with 255
	bcf	STATUS,RP0
	movlw	0x08
	movwf	CCPR1L
	movlw	0x03
	movwf	T2CON ; prescaler 1:16 and postscaler 1:1
	movlw	0x3C
	movwf	CCP1CON
	bsf	T2CON,TMR2ON
	return
;***************************************************
pause	movlw	0x60
	movwf	count1
d1	movlw	0xFA	  
	movwf	count2
d2	nop
	decfsz	count2,F	
	goto	d2		
	decfsz	count1,F	
	goto	d1		
	retlw	0x00
;***************************************************
warte	movlw	0x78	  
	movwf	count1
j3	btfss	infra
	goto	gata
	decfsz	count1,F	
	goto 	j3		
gata	return
;***************************************************
halta	movlw	0x94	  
	movwf	count1
j2	nop
	decfsz	count1,F	
	goto 	j2		
	return
;***************************************************
haltb	movlw	0x61	  
	movwf	count1
j1	decfsz	count1,F	
	goto 	j1		
	return
;***************************************************
	ORG	0x0300
span	nop
	movlw	0x03
	movwf	PCLATH
	movf	lamp,W
	addwf	PCL,F
	retlw 0x08
	retlw 0x10
	retlw 0x1F
	retlw 0x28
	retlw 0x33
	retlw 0x4F
	retlw 0x70
	retlw 0xA0
	retlw 0xFF
	retlw 0x80
;============================================================

	end
;============================================================
